import netscape.application.*;
import netscape.util.*;

// this application animates some shapes and strings
public class Drawings extends Application{
  Shapes shapes;
  Timer timer;
  
  public void init(){
      // create a new Shapes view and add it to the view hierarchy
      shapes = new Shapes(mainRootView().localBounds());
      mainRootView().addSubview(shapes);
      // create a Timer
      timer = new Timer(shapes,"moveShapes",50);
      // start the animation
      timer.start();
      
    }
  
  public void cleanup(){
      // stop the timer
      timer.stop();
      super.cleanup();
    }
}

class Shapes extends View implements Target{
  int h1,dx,w;
  int t = 0;
  Font font;
  
  public Shapes(Rect r){
      super(r);
      h1 = bounds().height/3;
      dx = bounds().width/4;
      w = bounds().width;
      font = new Font("Helvetica",Font.PLAIN,12);
      // setBuffered(true);

    }
  
  // overrides View.drawView() and does custom drawing
  public void drawView(Graphics g){
      // fill the background with cyan
      g.setColor(Color.cyan);
      g.fillRect(localBounds());
      // set the color to blue
      g.setColor(Color.blue);
      // Draw some shapes and strings. 
      // Their positions depend on the variable t.
      g.fillRect(t%w,h1*ycoord(t),20,20);
      g.fillRoundedRect((t+dx)%w,h1*ycoord(t+dx),20,20,5,5);
      g.drawOval((t+2*dx)%w,h1*ycoord(t+2*dx),20,20);
      g.drawRoundedRect((t+3*dx)%w,h1*ycoord(t+3*dx),20,20,5,5);
      // You must set the font or drawStringInRect won't work.
      g.setFont(font);
      g.drawStringInRect("Moving",(t+4*dx)%w,h1*ycoord(t+4*dx),
                         20,20,Graphics.CENTERED);
      g.drawStringInRect("Shapes",(t+5*dx)%w,h1*ycoord(t+5*dx),
                         20,20,Graphics.CENTERED);
      g.drawLine((t+6*dx)%w,h1*ycoord(t+6*dx),(t+6*dx)%w+20,
                 h1*ycoord(t+6*dx)+20);
      g.fillOval((t+7*dx)%w,h1*ycoord(t+7*dx),20,20);
      g.drawRect((t+8*dx)%w,h1*ycoord(t+8*dx),20,20);
    }
  
  // a method to compute the y coordinate of a shape.
  private int ycoord(int a){return ((a%(3*w))/w);}
  
  // called each time the timer fires
  public void performCommand(String command, Object data){
    if(command.equals("moveShapes")){
      t += 4;
      draw();
     } 
  } 
}
