import netscape.application.*;
import netscape.util.*;

// An example application that handles keyboard events
public class Keys extends Application{
  KeyView kview1,kview2;
  
  public void init(){
    int w = mainRootView().bounds().width;
    int h = mainRootView().bounds().height;
    kview1 = new KeyView(w/5,h/5,3*w/5,h/5,Color.blue);
    mainRootView().addSubview(kview1);
    kview2 = new KeyView(w/5,3*h/5,3*w/5,h/5,Color.green);
    mainRootView().addSubview(kview2);
  }
}

class KeyView extends View{
  Color color;
  int keynum;
  String key;
  boolean focusPaused = false;
  boolean inFocus = false;
  boolean focusStarted = false;
  
  public KeyView(int x, int y, int w, int h,Color c){
    super(x,y,w,h);
    color = c;
    keynum = 0;
    setBuffered(true);
  }
  
  public void drawView(Graphics g){
    g.setColor(color);
    g.fillRect(localBounds());
    g.setColor(Color.black);
    // the application has lost the focus, so the view's
    // focus has been paused.
    if(focusPaused){
      g.drawString("Focus paused",10,20);
      return;
    }
    // the user has clicked in the view, but 
    // hasn't typed a key yet.
    if(focusStarted){  
      g.drawString("In focus",10,20);
      focusStarted = false;
      return;
    }
    // the view is in focus and the user typed a key.
    if(inFocus) {
      g.drawString("You pressed the " + key + " key",10,20);
    }
    // the view is not in focus.
    else g.drawString("Not in Focus",10,20);
  }
  
  public void keyDown(KeyEvent e){
    keynum = e.key;
    
    // sort through some different possibilities for the key    
    if(e.isReturnKey()) key = "return";
    else if(e.isFunctionKey() != 0) key = "F" + e.isFunctionKey();
    else if(e.isRightArrowKey()) key = "right arrow";
    else if(e.isLeftArrowKey()) key = "left arrow";
    else if(e.isUpArrowKey()) key = "up arrow";
    else if(e.isDownArrowKey()) key = "down arrow";
    else key = String.valueOf((char) e.key);    

    if(e.isAltKeyDown()) key = "Alt key and the " + key;
    if(e.isControlKeyDown()){
       // do a conversions to find out which
       // key was pressed.
       char newKey = (char) (e.key - 1);
       newKey += 'a';
       key = String.valueOf(newKey);
       key = "Ctrl key and the " + key;
    }
    setDirty(true);
  }
  
  // set this to be the focused view when clicked on
  public boolean mouseDown(MouseEvent e){
    setFocusedView();
    return false;  // no need to handle mouseDragged()
  }

  // called when this is the focused view, and the
  // application loses focus.
  public void pauseFocus(){ focusPaused = true; draw(); }
  
  // called when the application regains the focus   
  public void resumeFocus(){ focusPaused = false; draw(); }
  
  // called when the view gains the focus
  public void startFocus(){
    inFocus = true;
    focusStarted = true;
    draw();
  }
  
  // called when the view loses the focus
  public void stopFocus(){ inFocus = false; draw(); }  
}
