import netscape.application.*;
import netscape.util.*;

// An example that shows how to handle mouse events in a view
public class Scribble extends Application{
  ScribbleView sview;  
  
  public void init(){
    super.init();
    // create a ScribbleView and add it to the hierarchy
    sview = new ScribbleView(mainRootView().localBounds());
    mainRootView().addSubview(sview);
  }
}

// A view that you can scribble in
class ScribbleView extends View{
  Vector linelist;
  int lastx,lasty;
  boolean drawLastLineOnly = false;
  
  public ScribbleView(Rect r){
    super(r);
    // linelist is a vector that keeps track of all
    // the lines that have been drawn.
    linelist = new Vector(1000);
    setBuffered(true);
  }
  
  public void drawView(Graphics g){
    // fill the background 
    g.setColor(Color.cyan);
    g.fillRect(localBounds());
    
    // set the line color
    g.setColor(Color.black);
    
    // draw the lines
    Line line;
    if(!linelist.isEmpty()){ 
      for(int k = 0;k < linelist.size();k++){
        line = (Line) linelist.elementAt(k);
        g.drawLine(line.x1,line.y1,line.x2,line.y2);
      }
    }
  } 
  
  public boolean mouseDown(MouseEvent e){
    lastx = e.x;
    lasty = e.y;
    // return true so mouseDragged() will be called
    return true;
  }
  
  public void mouseDragged(MouseEvent e){
    // ignore the dragging if the mouse is outside of the view
    if(!containsPointInVisibleRect(e.x,e.y)) return;
    
    // add the new line to the list
    linelist.addElement(new Line(lastx,lasty,e.x,e.y));
    
    // draw the line
    Graphics gr = createGraphics();     
    gr.drawLine(lastx,lasty,e.x,e.y);
    gr.dispose();  // don't forget this!
    
    // update the coordinates
    lastx = e.x;
    lasty = e.y;
  }
}

// helper class that represents a line segment
class Line{
  public int x1,x2,y1,y2;

  public Line(int x1,int y1,int x2,int y2){
    this.x1 = x1;
    this.x2 = x2;
    this.y1 = y1;
    this.y2 = y2;
  }
}
