import netscape.application.*;
import netscape.util.*;

public class TargetTest extends Application implements Target{
  Button addButton,clearButton;
  TextField tField;
  int pressnumber = 0;
  
  public void init(){
      mainRootView().setColor(Color.green);
       
      // create a button.  More on this in the next chapter.
      addButton = new Button(10,10,80,30);
      // set its command to something descriptive
      addButton.setCommand("addOne");
      // set its target.  Note that TargetTest implements Target.
      addButton.setTarget(this);
      addButton.setTitle("Press me");
      // Button extends View, so to use a button, it must be
      // added to the view hierarchy.
      mainRootView().addSubview(addButton);

      // create another button
      clearButton = new Button(100,10,80,30);
      clearButton.setCommand("clear");  // set its command
      clearButton.setTarget(this);  // set its target
      clearButton.setTitle("Clear");
      // add it to the view hierarchy
      mainRootView().addSubview(clearButton);

      // tField is a TextField that will display the number
      // of times the addButton has been pressed.
      Rect r = mainRootView().bounds;
      tField = new TextField(0,r.height/2,r.width,r.height/2);
      tField.setTransparent(true);
      tField.setJustification(Graphics.CENTERED);
      tField.setEditable(false);
      tField.setBuffered(true);
      mainRootView().addSubview(tField);
    }
 
    // We must define this method, since TargetTest implements Target
    public void performCommand(String command,Object data){
      // take appropriate action based on the command
      if(command.equals("addOne")) addOne();
      else if(command.equals("clear")) clear();
    }
  
    // add one to pressnumber and redraw the TextField
    private void addOne(){
      pressnumber++;
      tField.setStringValue("The button has been pressed " + pressnumber + 
			    " times.");
      tField.setDirty(true);
    }

    // set pressnumber to zero and redraw the TextField
    private void clear(){
      pressnumber = 0;
      tField.setStringValue("");
      tField.setDirty(true);
    }
}
