import netscape.application.*;
import netscape.util.*;

// A view to select a color
public class RGBView extends View implements Target{
  Slider sliders[];
  String sliderName[] = {"red","green","blue"};
  ContainerView container;
  TextField textFields[];
  ContainerView colorContainer;

  public RGBView(Rect r){ this(r.x,r.y,r.width,r.height);}
 
  public RGBView(int x,int y,int w,int h){
    super(x,y,w,h);
    setBuffered(true);
    container = new ContainerView(localBounds());

    sliders = new Slider[3];
    textFields = new TextField[3];
    int sliderHeight = 15;
   
    // create three sliders and three labels,
    // one pair for each of red, green, and blue.
    for(int j = 0;j<3;j++){
      sliders[j] = new Slider(10,10+2*j*sliderHeight,w-100,sliderHeight);
      sliders[j].setCommand("updateColors");
      sliders[j].setLimits(0,255);
      sliders[j].setValue(127);
      sliders[j].setTarget(this);

      textFields[j] = TextField.createLabel(sliderName[j] + " = 127 ");
      textFields[j].moveTo(w-80,10+2*j*sliderHeight);
      container.addSubview(sliders[j]);
      container.addSubview(textFields[j]);
    }

    // a ContainerView to display the current color
    colorContainer = new ContainerView(10,10+6*sliderHeight,
                   w-20,sliderHeight);

    colorContainer.setBorder(null);
    container.addSubview(colorContainer);
    addSubview(container);
    updateColor();
  }
  
  public void performCommand(String command, Object arg){
    if(command.equals("updateColors")) updateColor();
  }
  
  // update the current color and redraw the RGBView
  protected void updateColor(){
    for(int j = 0;j<3;j++){
      textFields[j].setStringValue(sliderName[j] + " = " + 
                 Integer.toString(sliders[j].value()));
    }
    Color c = new Color(sliders[0].value(),sliders[1].value(),
			    sliders[2].value());
    colorContainer.setBackgroundColor(c);
    container.setBorder(new LineBorder(c));
    setDirty(true);
  }

  // A public method to retrieve the color of the RGBView.
  public Color color(){ 
    Color c = new Color(sliders[0].value(),sliders[1].value(),
			    sliders[2].value());
    return c;
  }

  // A public method to set the color of the RGBView
  public void setColor(Color c){
    sliders[0].setValue(c.red());
    sliders[1].setValue(c.green());
    sliders[2].setValue(c.blue());
    updateColor();
  }
}
