import netscape.application.*;
import netscape.util.*;

// a Border subclass with a variable width and color
public class WideLineBorder extends Border{
  Color color;
  int margin;

  public WideLineBorder(int width, Color c){
    margin = width;
    color = c;
  }

  // The following five methods are the 
  // abstract methods from Border.
  public int bottomMargin(){return margin;};
  public int topMargin(){return margin;};
  public int leftMargin(){return margin;};
  public int rightMargin(){return margin;};

  // This method draws the WideLineBorder.  Note that it draws
  // only in the area specified by the four margin methods above.
  public void drawInRect(Graphics g,int x,int y,int w,int h){
    g.setColor(color);
    g.fillRect(x,y,w,margin);
    g.fillRect(x,y,margin,h);
    g.fillRect(w-margin,y,margin,h);
    g.fillRect(x,h-margin,w,margin);
  }
}
