import netscape.application.*;
import netscape.util.*;

public class MenuTest extends Application implements Target {
  InternalWindow win;
  static final String[] fileitems = { "New", "Open", "Save", "Save As..." };
  static final String[] edititems = { "Cut", "Copy", "Paste" };
  static final String[] helpitems = { "About" };

  public void init() {
    // Create menubar
    Menu menubar = new Menu(true);
    // Add items and pulldown panes to the menubar.
    MenuItem file = menubar.addItemWithSubmenu("File");
    MenuItem edit = menubar.addItemWithSubmenu("Edit");
    MenuItem help = menubar.addItemWithSubmenu("Help");
    // Put menu items in those pulldown panes
    fillMenuPane(file, this, fileitems);
    fillMenuPane(edit, this, edititems);
    fillMenuPane(help, this, helpitems);
    // Create a MenuView so the menu can be displayed in an InternalWindow
    MenuView mview = new MenuView(menubar);

    win = new InternalWindow();  // Create the InternalWindow
    win.setMenuView(mview);      // Set the MenuView in it
    win.moveTo(20, 20);          // Set window position and size
    win.sizeTo(250, 150);
    win.show();                  // And display it.
  }

  // A convenience routine for creating an array of menu items
  // It uses the menu item title as the command string, too.
  public void fillMenuPane(MenuItem item, Target target, String[] items) {
    Menu pane = item.submenu();
    for(int i = 0; i < items.length; i++)
      pane.addItem(items[i], items[i], target);
  }
  
  // A dummy target method that sets the window title to the command string
  public void performCommand(String command, Object data) {
    win.setTitle(command);
  }
}

