import netscape.application.*;
import netscape.util.*;

public class DialogView extends View implements Target{
  Image image;
  String title,message,buttonTitle,command;
  Label titleField,messageField;
  Button button;
  ContainerView imageView;
  int padding = 10;
  Target target;

  public DialogView(Image image,String title,String message,
		    String buttonTitle){
    this.image = image;
    this.title = title;
    this.message = message;
    this.buttonTitle = buttonTitle;

    createThings();

    Size sz = computeMinSize();
    sizeTo(sz.width,sz.height);
    // fix the button's x coordinate
    button.moveTo(width()/2-button.width()/2,button.y());

    addSubview(imageView);
    addSubview(titleField);
    addSubview(messageField);
    addSubview(button);
  }

  protected void createThings(){
    if(image != null){
      imageView = new ContainerView(10,10,image.width(),image.height());
      imageView.setBorder(null);
      imageView.setImage(image);
      imageView.setImageDisplayStyle(Image.CENTERED);
    }
    titleField = new Label(title,
          new Font("Helvetica",Font.BOLD,24));

    if(image != null){
      titleField.moveTo(image.width()+2*padding,
      padding + Math.max(0,image.height()-titleField.bounds.height));
    }
    else titleField.moveTo(padding,padding);

    messageField = new Label(message,Font.defaultFont());
    messageField.moveTo(padding,
            titleField.y() + titleField.height() + 2*padding);

    button = new Button();
    button.setTitle(buttonTitle);
    button.sizeToMinSize();
    // fix the button's y coordinate.
    // we can't fix the x coordinate yet because we don't know
    // how big the DialogView will be yet.
    button.moveTo(0,messageField.y() + messageField.height()+2*padding);

    button.setTarget(this);
    button.setCommand("buttonPressed");
  }
    
  protected Size computeMinSize(){
    Size size = new Size();
    size.width = size.height = 0;
    if(image != null){
      size.width = padding + image.width() +
                   padding + titleField.width() + padding;
      size.height = padding + Math.max(image.height(),titleField.height())
                    + padding;
    }
    else{
      size.width = titleField.width() + 2*padding;
      size.height = titleField.height() + 2*padding;
    }
    size.width = Math.max(size.width,2*padding + messageField.width());
    size.height += messageField.height() + 2*padding;

    size.width = Math.max(size.width,2*padding + button.width());
    size.height += 2*padding + button.height();

    return size;
  }

  public void setTarget(Target t){ target = t;}
  public void setCommand(String s){ command = s;}

  public void performCommand(String com, Object arg){
    if(com.equals("buttonPressed"))
      if(target != null) target.performCommand(command,this);
  }
}
