// A View to draw in 
import netscape.application.*;
import netscape.util.*;

public class ScribbleView extends View implements Target, ExtendedTarget{
  int lastx,lasty;
  Graphics gr;
  Color currentColor;
  boolean wasOutOfBounds = false;
  boolean thickLines = false;
  
  public ScribbleView(Rect r){
    super(r);
    currentColor = Color.blue;
  }
  
  public void performCommand(String command,Object data){
    if(command.equals("clearAll")) draw();  // calls drawView()
    if(command.equals("setOptions")){       // set drawing options
      Parameters p = (Parameters) data;
      currentColor = p.color;
      thickLines = p.thickLines;
    }
  }
  
  public void drawView(Graphics g){ 
    g.setColor(Color.white);
    g.fillRect(localBounds());
  } 
  
  public boolean mouseDown(MouseEvent e){
    wasOutOfBounds = false;
    gr = createGraphics();
    lastx = e.x;
    lasty = e.y;
    return true;
  }
  
  public void mouseDragged(MouseEvent e){
    if(!containsPointInVisibleRect(e.x,e.y) || 
       viewForMouse(e.x,e.y) != this){
      wasOutOfBounds = true;
      return; 
    }
    if(wasOutOfBounds) return;
    gr.setColor(currentColor);
    
    if(thickLines){
      // draw four lines around the center line
      gr.drawLine(lastx-1,lasty,e.x-1,e.y);
      gr.drawLine(lastx+1,lasty,e.x+1,e.y);
      gr.drawLine(lastx,lasty-1,e.x,e.y-1);
      gr.drawLine(lastx,lasty+1,e.x,e.y+1);
    }
    // draw the center line
    gr.drawLine(lastx,lasty,e.x,e.y);
    
    lastx = e.x;
    lasty = e.y;
  }
  
  public void mouseUp(MouseEvent e){ gr.dispose();}
  
  public Parameters options(){
    Parameters p = new Parameters(currentColor,thickLines);
    return p;
  }
  
  // ExtendedTarget command.
  // We need this because ScribbleView will be in the TargetChain.
  public boolean canPerformCommand(String command){
    if(command.equals("setOptions")) return true;
    if(command.equals("clearAll")) return true;
    else return false;
  }
}
