import netscape.application.*;
import netscape.util.*;

// A Timer example that performs some simple animation
public class Dots extends Application{
  MovingDots mdots;
  
  public void init(){
    mdots = new MovingDots(mainRootView().localBounds());
    mainRootView().addSubview(mdots);
  }
}

// A view class that uses a Timer to do some animation
class MovingDots extends View implements Target{
  Button startbutton,stopbutton;
  int x1,y1,x2,y2;
  double time,dt;
  Timer timer;
  double dw,dh;
  
  public MovingDots(Rect r){
    super(r);
    setBuffered(true);  // use bufferd drawing
    dh = (double) (r.height/2);
    dw = (double) (r.width/2);
    // (x1,y1) and (x2,y2) are the coordinates of the "dots"
    x1 = r.width/2 + r.width/4;  
    x2 = r.width/2 - r.width/4;
    y1 = y2 = r.height/2;

    // start at time = 0
    time = 0.0;
    dt = 0.1;
    // create a Timer with 40 milliseconds between firings
    timer = new Timer(this,"movedot",40);  
    
    // a start button
    startbutton = new Button(10,10,50,30);
    startbutton.setTitle("Start");
    startbutton.setTarget(this);
    startbutton.setCommand("start");
    
    // a stop button
    stopbutton = new Button(10,50,50,30);
    stopbutton.setTitle("Stop");
    stopbutton.setTarget(this);
    stopbutton.setCommand("stop");
    
    addSubview(startbutton);
    addSubview(stopbutton);
  }
  
  public void drawView(Graphics g){
    // draw the background
    g.setColor(Color.cyan);
    g.fillRect(localBounds());
    // draw the two dots as circles with radius 10
    g.setColor(Color.blue);
    g.fillOval(x1,y1,10,10);
    g.fillOval(x2,y2,10,10);
  }
  
  public void performCommand(String command, Object anObject){
    if(command.equals("movedot")){
      // update the position of the dots
      int x = (int) (dw*Math.cos(3.0*time));
      int y =  (int) (dh*Math.sin(2.0*time));
      y1 = bounds.height/2 + y/2;
      x1 = bounds.width/2 + x/2;
      y2 = bounds.height/2 - y/2;
      x2 = bounds.width/2 - x/2;
      // increment time
      time += dt;
      // redraw the dots
      draw();
    }
    if(command.equals("start")){ timer.start();}
    if(command.equals("stop")){ timer.stop();}
  }
}
