import netscape.application.*;
import netscape.util.*;

public class ImageView extends View implements DrawingSequenceOwner{
  ImageSequence images;
  
  public ImageView(int x,int y,int w,int h){
    super(x,y,w,h);
    images = new ImageSequence(this);
    setupImages();
    images.setPlaybackMode(DrawingSequence.FORWARD_LOOP);
    images.setFrameRate(100);
  }
  
  private void setupImages(){
    for(int j=1;j<=8;j++){
      images.addImage(Bitmap.bitmapNamed("picture" + j + ".gif"));
    }
  }
  
  public void drawingSequenceFrameChanged(DrawingSequence d){ draw();}
  public void drawingSequenceCompleted(DrawingSequence d){}
  public void drawView(Graphics g){ images.drawAt(g,0,0);}
  public void start(){ images.start();}
  public void stop(){ images.stop();}
}
