import netscape.application.*;
import netscape.util.*;

public class TextTest extends Application{
  TextView tview;
  InternalWindow textWindow,imageWindow;
  DragWell imageWell;

  public void init(){
    // create the window with the TextView
    setupTextWindow();
    textWindow.setContainsDocument(true);
    tview.setFocusedView();
    makeCurrentDocumentWindow(textWindow);    
    // create a window with a DragWell 
    setupImageWindow();
    // show the font and color choosers
    mainRootView().showColorChooser();
    mainRootView().showFontChooser();
  }

  // creates a TextView in an InternalWindow
  protected void setupTextWindow(){
    // a TextView and a window to put it in
    textWindow = new InternalWindow();
    tview = new TextView(0,0,300,800);
 
    // put the TextView in a ScrollGroup
    ScrollGroup textGroup = new ScrollGroup(0,0,250,150);
    textGroup.setHasVertScrollBar(true);
    textGroup.setVertScrollBarDisplay(ScrollGroup.AS_NEEDED_DISPLAY);
    textGroup.setHasHorizScrollBar(true);
    textWindow.setResizable(true);

    Size s = textWindow.windowSizeForContentSize(textGroup.width(),
                           textGroup.height());

    textGroup.setContentView(tview);  // add the TextView to the ScrollGroup
    textGroup.scrollView().setBuffered(true);
    textWindow.addSubview(textGroup);
    textWindow.sizeTo(s.width,s.height);   // size the window
    textWindow.moveTo(10,10);
    textWindow.show();          // show it
  }
  
  // creates an InternalWindow with a DragWell
  protected void setupImageWindow(){
    // create and show the InternalWindow
    imageWindow = new InternalWindow();  
    imageWell = new DragWell(0,0,50,50);
    Size s = imageWindow.windowSizeForContentSize(imageWell.width(),
                              imageWell.height());
    imageWindow.sizeTo(s.width,s.height);
    imageWindow.addSubview(imageWell);
    imageWindow.center();
    imageWindow.show();

    // create an Image for the DragWell
    Bitmap bitmap = new Bitmap(imageWell.width(),imageWell.height());
    Graphics g = bitmap.createGraphics();
    g.setColor(Color.cyan);
    g.fillRect(0,0,bitmap.width(),bitmap.height());
    g.setColor(Color.black);
    g.fillOval(imageWell.width()/4,imageWell.height()/4,
	       imageWell.width()/2,imageWell.height()/2);
    g.dispose();

    // set the DragWell's data to be the Image
    imageWell.setData(bitmap);
    imageWell.setImage(bitmap);
    imageWell.setDataType(Image.IMAGE_TYPE);
  }
}
